# Ogre::Codec Class Reference
General

Abstract class that defines a 'codec'. More...

`#include <OgreCodec.h>`

Inheritance diagram for Ogre::Codec:
[legend]

List of all members.

## Classes

class | CodecData

## Public Types

typedef SharedPtr< CodecData > | CodecDataPtr
typedef ConstMapIterator < CodecList > | CodecIterator
typedef std::pair < MemoryDataStreamPtr, CodecDataPtr > | DecodeResult
| Result of a decoding; both a decoded data stream and CodecData metadata.

## Public Member Functions

virtual | ~Codec ()
virtual DataStreamPtr | code (MemoryDataStreamPtr &input, CodecDataPtr &pData) const =0
| Codes the data in the input stream and saves the result in the output stream.
virtual void | codeToFile (MemoryDataStreamPtr &input, const String &outFileName, CodecDataPtr &pData) const =0
| Codes the data in the input chunk and saves the result in the output filename provided.
virtual DecodeResult | decode (DataStreamPtr &input) const =0
| Codes the data from the input chunk into the output chunk.
virtual String | getType () const =0
| Returns the type of the codec as a String.
virtual String | getDataType () const =0
| Returns the type of the data that supported by this codec as a String.
virtual bool | magicNumberMatch (const char *magicNumberPtr, size_t maxbytes) const
| Returns whether a magic number header matches this codec.
virtual String | magicNumberToFileExt (const char *magicNumberPtr, size_t maxbytes) const =0
| Maps a magic number header to a file extension, if this codec recognises it.
void * | operator new (size_t sz, const char *file, int line, const char *func)
| operator new, with debug line info
void * | operator new (size_t sz)
void * | operator new (size_t sz, void *ptr)
| placement operator new
void * | operator new[] (size_t sz, const char *file, int line, const char *func)
| array operator new, with debug line info
void * | operator new[] (size_t sz)
void | operator delete (void *ptr)
void | operator delete (void *ptr, void *)
void | operator delete (void *ptr, const char *, int, const char *)
void | operator delete[] (void *ptr)
void | operator delete[] (void *ptr, const char *, int, const char *)

## Static Public Member Functions

static void | registerCodec (Codec *pCodec)
| Registers a new codec in the database.
static bool | isCodecRegistered (const String &codecType)
| Return whether a codec is registered already.
static void | unRegisterCodec (Codec *pCodec)
| Unregisters a codec from the database.
static CodecIterator | getCodecIterator (void)
| Gets the iterator for the registered codecs.
static StringVector | getExtensions (void)
| Gets the file extension list for the registered codecs.
static Codec * | getCodec (const String &extension)
| Gets the codec registered for the passed in file extension.
static Codec * | getCodec (char *magicNumberPtr, size_t maxbytes)
| Gets the codec that can handle the given 'magic' identifier.

## Protected Types

typedef map< String, Codec * > ::type | CodecList

## Static Protected Attributes

static CodecList | ms_mapCodecs
| A map that contains all the registered codecs.

## Detailed Description

Abstract class that defines a 'codec'.

Remarks:
  A codec class works like a two-way filter for data - data entered on one end (the decode end) gets processed and transformed into easily usable data while data passed the other way around codes it back.

  The codec concept is a pretty generic one - you can easily understand how it can be used for images, sounds, archives, even compressed data.

Definition at line 55 of file OgreCodec.h.

## Member Typedef Documentation

typedef SharedPtr<CodecData> Ogre::Codec::CodecDataPtr

Definition at line 73 of file OgreCodec.h.

typedef ConstMapIterator<CodecList> Ogre::Codec::CodecIterator

Definition at line 75 of file OgreCodec.h.

typedef map< String, Codec* >::type Ogre::Codec::CodecList`[protected]`

Definition at line 58 of file OgreCodec.h.

typedef std::pair<MemoryDataStreamPtr, CodecDataPtr> Ogre::Codec::DecodeResult

Result of a decoding; both a decoded data stream and CodecData metadata.

Definition at line 140 of file OgreCodec.h.

## Constructor & Destructor Documentation

virtual Ogre::Codec::~Codec | ( |  | ) | `[virtual]`

## Member Function Documentation

virtual DataStreamPtr Ogre::Codec::code | ( | MemoryDataStreamPtr & | input,
|  | CodecDataPtr & | pData
| ) |  | const`[pure virtual]`

Codes the data in the input stream and saves the result in the output stream.

Implemented in Ogre::DDSCodec, Ogre::FreeImageCodec, Ogre::ILImageCodec, and Ogre::PVRTCCodec.

virtual void Ogre::Codec::codeToFile | ( | MemoryDataStreamPtr & | input,
|  | const String & | outFileName,
|  | CodecDataPtr & | pData
| ) |  | const`[pure virtual]`

Codes the data in the input chunk and saves the result in the output filename provided.

Provided for efficiency since coding to memory is progressive therefore memory required is unknown leading to reallocations.

Parameters:

  input | The input data
  outFileName | The filename to write to
  pData | Extra information to be passed to the codec (codec type specific)

Implemented in Ogre::DDSCodec, Ogre::FreeImageCodec, Ogre::ILImageCodec, and Ogre::PVRTCCodec.

virtual DecodeResult Ogre::Codec::decode | ( | DataStreamPtr & | input | ) | const`[pure virtual]`

Codes the data from the input chunk into the output chunk.

Parameters:

  input | Stream containing the encoded data

Note:
  Has a variable number of arguments, which depend on the codec type.

Implemented in Ogre::DDSCodec, Ogre::FreeImageCodec, Ogre::ILImageCodec, and Ogre::PVRTCCodec.

static Codec* Ogre::Codec::getCodec | ( | const String & | extension | ) | `[static]`

Gets the codec registered for the passed in file extension.

static Codec* Ogre::Codec::getCodec | ( | char * | magicNumberPtr,
|  | size_t | maxbytes
| ) |  | `[static]`

Gets the codec that can handle the given 'magic' identifier.

Parameters:

  magicNumberPtr | Pointer to a stream of bytes which should identify the file. Note that this may be more than needed - each codec may be looking for a different size magic number.
  maxbytes | The number of bytes passed

static CodecIterator Ogre::Codec::getCodecIterator | ( | void |  | ) | `[static]`

Gets the iterator for the registered codecs.

Definition at line 107 of file OgreCodec.h.

virtual String Ogre::Codec::getDataType | ( |  | ) | const`[pure virtual]`

Returns the type of the data that supported by this codec as a String.

Implemented in Ogre::ImageCodec.

static StringVector Ogre::Codec::getExtensions | ( | void |  | ) | `[static]`

Gets the file extension list for the registered codecs.

virtual String Ogre::Codec::getType | ( |  | ) | const`[pure virtual]`

Returns the type of the codec as a String.

Implemented in Ogre::DDSCodec, Ogre::FreeImageCodec, Ogre::ILImageCodec, and Ogre::PVRTCCodec.

Referenced by registerCodec(), and unRegisterCodec().

static bool Ogre::Codec::isCodecRegistered | ( | const String & | codecType | ) | `[static]`

Return whether a codec is registered already.

Definition at line 94 of file OgreCodec.h.

virtual bool Ogre::Codec::magicNumberMatch | ( | const char * | magicNumberPtr,
|  | size_t | maxbytes
| ) |  | const`[virtual]`

Returns whether a magic number header matches this codec.

Parameters:

  magicNumberPtr | Pointer to a stream of bytes which should identify the file. Note that this may be more than needed - each codec may be looking for a different size magic number.
  maxbytes | The number of bytes passed

Definition at line 162 of file OgreCodec.h.

virtual String Ogre::Codec::magicNumberToFileExt | ( | const char * | magicNumberPtr,
|  | size_t | maxbytes
| ) |  | const`[pure virtual]`

Maps a magic number header to a file extension, if this codec recognises it.

Parameters:

  magicNumberPtr | Pointer to a stream of bytes which should identify the file. Note that this may be more than needed - each codec may be looking for a different size magic number.
  maxbytes | The number of bytes passed

Returns:
  A blank string if the magic number was unknown, or a file extension.

Implemented in Ogre::DDSCodec, Ogre::FreeImageCodec, Ogre::ILImageCodec, and Ogre::PVRTCCodec.

template<class Alloc >

void Ogre::AllocatedObject< Alloc >::operator delete | ( | void * | ptr,
|  | const char * | ,
|  | int | ,
|  | const char * |
| ) |  | `[inherited]`

Definition at line 107 of file OgreMemoryAllocatedObject.h.

template<class Alloc >

void Ogre::AllocatedObject< Alloc >::operator delete | ( | void * | ptr | ) | `[inherited]`

Definition at line 95 of file OgreMemoryAllocatedObject.h.

template<class Alloc >

void Ogre::AllocatedObject< Alloc >::operator delete | ( | void * | ptr,
|  | void * |
| ) |  | `[inherited]`

Definition at line 101 of file OgreMemoryAllocatedObject.h.

template<class Alloc >

void Ogre::AllocatedObject< Alloc >::operator delete[] | ( | void * | ptr | ) | `[inherited]`

Definition at line 112 of file OgreMemoryAllocatedObject.h.

template<class Alloc >

void Ogre::AllocatedObject< Alloc >::operator delete[] | ( | void * | ptr,
|  | const char * | ,
|  | int | ,
|  | const char * |
| ) |  | `[inherited]`

Definition at line 118 of file OgreMemoryAllocatedObject.h.

template<class Alloc >

void* Ogre::AllocatedObject< Alloc >::operator new | ( | size_t | sz | ) | `[inherited]`

Definition at line 72 of file OgreMemoryAllocatedObject.h.

template<class Alloc >

void* Ogre::AllocatedObject< Alloc >::operator new | ( | size_t | sz,
|  | void * | ptr
| ) |  | `[inherited]`

placement operator new

Definition at line 78 of file OgreMemoryAllocatedObject.h.

template<class Alloc >

void* Ogre::AllocatedObject< Alloc >::operator new | ( | size_t | sz,
|  | const char * | file,
|  | int | line,
|  | const char * | func
| ) |  | `[inherited]`

operator new, with debug line info

Definition at line 67 of file OgreMemoryAllocatedObject.h.

template<class Alloc >

void* Ogre::AllocatedObject< Alloc >::operator new[] | ( | size_t | sz,
|  | const char * | file,
|  | int | line,
|  | const char * | func
| ) |  | `[inherited]`

array operator new, with debug line info

Definition at line 85 of file OgreMemoryAllocatedObject.h.

template<class Alloc >

void* Ogre::AllocatedObject< Alloc >::operator new[] | ( | size_t | sz | ) | `[inherited]`

Definition at line 90 of file OgreMemoryAllocatedObject.h.

static void Ogre::Codec::registerCodec | ( | Codec * | pCodec | ) | `[static]`

Registers a new codec in the database.

Definition at line 82 of file OgreCodec.h.

References Ogre::Exception::ERR_DUPLICATE_ITEM, getType(), and OGRE_EXCEPT.

static void Ogre::Codec::unRegisterCodec | ( | Codec * | pCodec | ) | `[static]`

Unregisters a codec from the database.

Definition at line 101 of file OgreCodec.h.

References getType().

## Member Data Documentation

CodecList Ogre::Codec::ms_mapCodecs`[static, protected]`

A map that contains all the registered codecs.

Definition at line 61 of file OgreCodec.h.

The documentation for this class was generated from the following file:

- OgreCodec.h

Copyright © 2008 Torus Knot Software Ltd
This work is licensed under a Creative Commons Attribution-ShareAlike 3.0 Unported License.
Last modified Sun May 8 2011 20:28:10